Bug 16974: Make koha-plack should check and fix log files permissions
[koha.git] / debian / scripts / koha-plack
blobed0f42103d48bcd4d512ca58ee3b4c8d97470870
1 #!/bin/bash
3 # Copyright 2015 Theke Solutions
5 # This file is part of Koha.
7 # This program is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 3 of the License, or
10 # (at your option) any later version.
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
17 # You should have received a copy of the GNU General Public License
18 # along with this program. If not, see <http://www.gnu.org/licenses/>.
20 set -e
22 . /lib/lsb/init-functions
24 # Read configuration variable file if it is present
25 [ -r /etc/default/koha-common ] && . /etc/default/koha-common
27 # include helper functions
28 if [ -f "/usr/share/koha/bin/koha-functions.sh" ]; then
29 . "/usr/share/koha/bin/koha-functions.sh"
30 else
31 echo "Error: /usr/share/koha/bin/koha-functions.sh not present." 1>&2
32 exit 1
35 usage()
37 local scriptname=$(basename $0)
39 cat <<EOF
40 $scriptname
42 This script lets you manage the plack daemons for your Koha instances.
44 Usage:
45 $scriptname --start|--stop|--restart [--quiet|-q] instancename1 [instancename2...]
46 $scriptname --enable|--disable instancename1 [instancename2]
47 $scriptname -h|--help
49 --start Start the plack daemon for the specified instances
50 --stop Stop the plack daemon for the specified instances
51 --restart Restart the plack daemon for the specified instances
52 --enable Enable plack for the specified instances
53 --disable Disable plack for the specified instances
54 --quiet|-q Make the script quiet about non existent instance names
55 (useful for calling from another scripts).
56 --help|-h Display this help message
58 EOF
61 start_plack()
63 local instancename=$1
65 local PIDFILE="/var/run/koha/${instancename}/plack.pid"
66 local PLACKSOCKET="/var/run/koha/${instancename}/plack.sock"
67 local PSGIFILE="/etc/koha/plack.psgi"
68 local NAME="${instancename}-koha-plack"
70 if [ -e "/etc/koha/sites/${instancename}/plack.psgi" ]; then
71 # pick instance-specific psgi file
72 PSGIFILE="/etc/koha/sites/${instancename}/plack.psgi"
73 fi # else stick with the default one
75 _check_and_fix_perms $instancename
77 STARMANOPTS="-M FindBin --max-requests 50 --workers 2 \
78 --user=${instancename}-koha --group ${instancename}-koha \
79 --pid ${PIDFILE} \
80 --daemonize \
81 --access-log /var/log/koha/${instancename}/plack.log \
82 --error-log /var/log/koha/${instancename}/plack-error.log \
83 -E deployment --socket ${PLACKSOCKET} ${PSGIFILE}"
85 if ! is_plack_running ${instancename}; then
86 export KOHA_CONF="/etc/koha/sites/${instancename}/koha-conf.xml"
88 log_daemon_msg "Starting Plack daemon for ${instancename}"
90 if ${STARMAN} ${STARMANOPTS}; then
91 log_end_msg 0
92 else
93 log_end_msg 1
95 else
96 log_daemon_msg "Error: Plack already running for ${instancename}"
97 log_end_msg 1
101 stop_plack()
103 local instancename=$1
105 local PIDFILE="/var/run/koha/${instancename}/plack.pid"
107 if is_plack_running ${instancename}; then
109 log_daemon_msg "Stopping Plack daemon for ${instancename}"
111 if start-stop-daemon --pidfile ${PIDFILE} --stop; then
112 log_end_msg 0
113 else
114 log_end_msg 1
116 else
117 log_daemon_msg "Error: Plack not running for ${instancename}"
118 log_end_msg 1
122 restart_plack()
124 local instancename=$1
126 local PIDFILE="/var/run/koha/${instancename}/plack.pid"
128 if is_plack_running ${instancename}; then
130 log_daemon_msg "Restarting Plack daemon for ${instancename}"
132 if stop_plack $instancename && start_plack $instancename; then
133 log_end_msg 0
134 else
135 log_end_msg 1
137 else
138 log_daemon_msg "Error: Plack not running for ${instancename}"
139 log_end_msg 1
143 enable_plack()
145 local instancename=$1
146 local instancefile=$(get_apache_config_for "$instancename")
148 if ! is_plack_enabled $instancename; then
149 # Uncomment the plack related lines for OPAC and intranet
150 sed -i 's:^\s*#\(\s*Include /etc/koha/apache-shared-opac-plack.conf\)$:\1:' "$instancefile"
151 sed -i 's:^\s*#\(\s*Include /etc/koha/apache-shared-intranet-plack.conf\)$:\1:' "$instancefile"
152 [ "${quiet}" != "yes" ] && warn "Plack enabled for ${instancename}"
153 return 0
154 else
155 [ "${quiet}" != "yes" ] && warn "Plack already enabled for ${instancename}"
156 return 1
160 disable_plack()
162 local instancename=$1
163 local instancefile=$(get_apache_config_for "$instancename")
165 if is_plack_enabled $instancename; then
166 # Comment out the plack related lines for OPAC and intranet
167 sed -i 's:^\(\s*Include /etc/koha/apache-shared-opac-plack.conf\)$:#\1:' "$instancefile"
168 sed -i 's:^\(\s*Include /etc/koha/apache-shared-intranet-plack.conf\)$:#\1:' "$instancefile"
169 [ "${quiet}" != "yes" ] && warn "Plack disabled for ${instancename}"
170 return 0
171 else
172 [ "${quiet}" != "yes" ] && warn "Plack already disabled for ${instancename}"
173 return 1
177 check_env_and_warn()
179 local apache_version_ok="no"
180 local required_modules="headers proxy_http"
181 local missing_modules=""
183 if /usr/sbin/apache2ctl -v | grep -q "Server version: Apache/2.4"; then
184 apache_version_ok="yes"
187 for module in ${required_modules}; do
188 if ! /usr/sbin/apachectl -M 2> /dev/null | grep -q ${module}; then
189 missing_modules="${missing_modules}${module} "
191 done
193 if [ "${apache_version_ok}" != "yes" ]; then
194 warn "WARNING: koha-plack requires Apache 2.4.x and you don't have that."
197 if [ "${missing_modules}" != "" ]; then
198 cat 1>&2 <<EOM
199 WARNING: koha-plack requires some Apache modules that you are missing.
200 You can install them with:
202 sudo a2enmod ${missing_modules}
209 _check_and_fix_perms()
211 local instance=$1
213 local files="/var/log/koha/${instance}/plack.log \
214 /var/log/koha/${instance}/plack-error.log"
216 for file in ${files}
218 if [ ! -e "${file}" ]; then
219 touch ${file}
221 chown "${instance}-koha":"${instance}-koha" ${file}
222 done
225 set_action()
227 if [ "$op" = "" ]; then
228 op=$1
229 else
230 die "Error: only one action can be specified."
234 STARMAN=$(which starman)
235 op=""
236 quiet="no"
238 # Read command line parameters
239 while [ $# -gt 0 ]; do
241 case "$1" in
242 -h|--help)
243 usage ; exit 0 ;;
244 -q|--quiet)
245 quiet="yes"
246 shift ;;
247 --start)
248 set_action "start"
249 shift ;;
250 --stop)
251 set_action "stop"
252 shift ;;
253 --restart)
254 set_action "restart"
255 shift ;;
256 --enable)
257 set_action "enable"
258 shift ;;
259 --disable)
260 set_action "disable"
261 shift ;;
263 die "Error: invalid option switch ($1)" ;;
265 # We expect the remaining stuff are the instance names
266 break ;;
267 esac
269 done
271 if [ -z $PERL5LIB ]; then
272 PERL5LIB="/usr/share/koha/lib"
275 export PERL5LIB
277 [ "${quiet}" != "yes" ] && check_env_and_warn
279 if [ $# -gt 0 ]; then
280 # We have at least one instance name
281 for name in "$@"; do
283 if is_instance $name; then
285 case $op in
286 "start")
287 start_plack $name
289 "stop")
290 stop_plack $name
292 "restart")
293 restart_plack $name
295 "enable")
296 enable_plack $name
298 "disable")
299 disable_plack $name
302 usage
304 esac
306 else
307 if [ "$quiet" = "no" ]; then
308 log_daemon_msg "Error: Invalid instance name $name"
309 log_end_msg 1
313 done
314 else
315 if [ "$quiet" = "no" ]; then
316 warn "Error: you must provide at least one instance name"
320 exit 0